'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///
'//////////////////////////////////////////////////////////
$Device= 8515				' used device
$Stack = 32                	' stack size
$Clock = 8
$Timer1=Timer, Prescale=256
$GLCD HD61202, data=PORTA, ctrl=PORTC, 128, 64, 2
$Gctrl CS1=1, CS2=0, DI=2, WR=3, EN=4
$1Wire=PORTB.2
$Source= On

Declare Sub DrawBox(a As Byte, b As Byte, c As Byte, d As Byte)

Dim x As Byte, y As Byte
Dim xold As Byte, yold As Byte
Dim xx As Byte, yy As Byte
Dim xxx As Byte, yyy As Byte
Dim w As Byte

Dim Xdir As Bit, Ydir As Bit

Const True=1, False=0
Const Xmax=50, Ymax=35
Const Xmin=10, Ymin=10
Const Delay=60

Set DDRC.5
Set PORTC.5

x=Xmin:y=Ymin
Xdir=1:Ydir=1

GLcdInit
Gcls

DrawBox(Xmin,Ymin,Xmax,Ymax)

Do
	If Xdir Then
		Incr x
		If x>Xmax Then
			Xdir=False
			x=Xmax
		End If
	Else
		Decr x
		If x=Xmin Then
			Xdir=True
		End If
	End If
	If Ydir Then
		Incr y
		If y>Ymax Then
			Ydir=False
			y=Ymax
		End If
	Else
		Decr y
		If y=Ymin Then
			Ydir=True
		End If
	End If
	Pset(x,y),1
	WaitMs Delay

	Pset(xold,yold),0
	DrawBox(Xmin,Ymin,Xmax,Ymax)
	WaitMs Delay

	xold=xxx:yold=yyy
	xxx=xx:yyy=yy
	xx=x:yy=y
Loop

'//////////////////////////////////////////////////////////
Sub DrawBox(a As Byte, b As Byte, c As Byte, d As Byte)
LineH(a,b,c),1
LineH(a,d,c),1
LineV(a,b,d),1
LineV(c,b,d),1
End Sub
