'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///    Crc16 calculation                               ///
'///    Crc16.bas                     www.FastAVR.com   ///
'//////////////////////////////////////////////////////////
$Device= 8515				' used device
$Stack = 16                	' stack size
$Clock = 7.3728
$Source= On
            
Dim n As Byte
Dim n1 As Byte
Dim n2 As Byte
Dim n3 As Byte
Dim n4 As Byte
Dim n5 As Byte
Dim Crc As Word

Declare Sub Crc16(adr As Byte, cnt As Byte)
Declare Sub CalcCrc(tmp As Byte)

Crc=0
n=2
n1=3
n2=4
n3=5
n4=40
n5=89

Crc16(VarPtr(n),5)		'pass adr of var n
End

'//////////////////////////////////////////////////////////
Sub Crc16(adr As Byte, cnt As Byte)		'for SRAM < 256
Local i As Byte
    
    For i=0 To cnt
		CalcCrc(Peek(adr+i))	
	Next
End Sub

'//////////////////////////////////////////////////////////
Sub CalcCrc(tmp As Byte)	'calc 16bit CRC on single byte
Local i As Byte
    
    Crc = MakeWord(tmp,0) Xor Crc
    For i = 0 To 7
	    If Crc.15 = 0 Then
		 	Shift(Left,1,Crc)
		Else
		 	Shift(Left,1,Crc)
			Crc = Crc Xor &h1021	'&h1021 is CRC poly
		End If
    Next
End Sub
