'/////////////////////////////////////////////////////////
'///   FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///   RC5 test program                                ///
'///   RC5.bas                       www.FastAVR.com   ///
'/////////////////////////////////////////////////////////
' Command displays on LEDs on PORTB
' LEDs are btw PORTB and Vcc via 1k resistors
$Device= 8515			' used device
$Stack = 32				' stack depth
$Clock = 4				' used cristal
$RC5=PORTD.2
$Source=On

Dim SysAdr As Byte, Command As Byte

Const IR=&h03			' my IR SysAdr

PORTB=&hff             	' Leds OFF
DDRB =&hff				' PORTB is output
Enable Timer0			' needs by RC5
Enable Interrupts

Do
	RC5(SysAdr, Command)				' wait for RC5
	SysAdr=SysAdr And &h1f				' cut out toggle bit
	If Sysadr=IR And Command<255 Then	' our IR and no error?
		PORTB=Not Command				' yes, show it on PORTB   
	End If 
Loop

